//
//  MyDocument.h
//  Plot
//
//  Created by Cedric John on Sat Oct 26 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
// This is the Document file for Plot, and is the document controller as well. Sort of the center piece, really!

#import <Cocoa/Cocoa.h>
#import <Controller.h>
#import "PDFView.h"
#import "DataPoint.h"
#import "Controller.h"
#import "TXTParser.h"

@class Controller, PDFView, DataPoint, TXTParser;

@interface MyDocument : NSDocument
{
 IBOutlet PDFView *plotView;
 IBOutlet NSWindow *plotWindow;
 IBOutlet NSPopUpButton *folderPopUp;
 IBOutlet NSPopUpButton *plotPopUp;
 IBOutlet NSBrowser *fileBrowser;
 IBOutlet NSTableView *tableView;
 IBOutlet NSColorWell *colorWell;
 IBOutlet NSColorWell *gradientColorWell;
 IBOutlet NSButton *removeButton;
 IBOutlet NSSlider *sizeSlider;
 IBOutlet NSTextField *sizeField;
 IBOutlet NSButton *isVisibleButton;
 IBOutlet NSButton *isLinkedButton;
 IBOutlet NSButton *gradientButton;
 IBOutlet NSButton *gradientTypeButton;
 IBOutlet NSPopUpButton *pointShape;
 IBOutlet NSTextField *serieNameField;
 IBOutlet NSPanel *namePanel;
 IBOutlet NSWindow *dataWindow;
 IBOutlet TXTParser *txtParser;
 IBOutlet NSView *openPanelView;
 IBOutlet NSPopUpButton *sortButton;

 NSMutableDictionary *interfaceDictionary; // a dic of all the interface objects
 NSMutableArray *plotWindowArray; //to save the data associated with the plotView
 NSMutableArray *fileArray;
 NSMutableArray *fileNameArray;
 NSFileWrapper *plotDirectory;
 NSOpenPanel *thePanel;
 NSSavePanel *theSavePanel;
 NSRect plotViewRect;
 int currentShape;
 int currentColor;
 BOOL loadingFromFile;
}
 
- (void) setFileArray: (NSMutableArray *) newArray;
- (NSMutableArray *) fileArray;
- (int) currentShape;
- (int) currentColor;

- (NSRect) plotViewRect;
- (NSMutableArray *)plotWindowArray;
 
- (void) setPopUpIcons;
- (void) chooseAPlot: (id) sender;
- (void) updateDirectory: (id) sender;
- (void) addFile: (id) sender;
- (void) drawFiles: (id) sender;
- (void) performAddFiles: (NSMutableDictionary *) dataSet;
- (void) sendNextFileFromDrag;
- (void) chooseFiles;
- (void) changeFileName; //sent by double action
- (void) changeName:(id) sender; //sent by the name panel
- (void) sortData: (id) sender; //re-sorting the data
- (void) updateGraphic: (id) sender;
- (void) updateSize: (id) sender;
- (void) removeFile:(id)sender;
- (void) performRemoveFile;
- (void) deleteSelectedFiles;
- (void) exportPDF: (id) sender;
- (void) extractData: (id) sender;
- (void) initDefaultPreferences; //if no user defaults have been set
- (void) makeSubset:(id) sender;
- (IBAction) addPointsToSerie: (id) sender;
- (IBAction) selectPointsFromSerie: (id) sender;


@end
